<?php
/**
* @Created:		P30doctor.com (Abolfazl Talebi)
* @version:		P30 News v1.0
* @package:		Joomla
* @copyright:	Copyright (C) 2010 - 2011 P30doctor. All rights reserved.
* @license:		GNU/GPL, see LICENSE.php
* @Email:		abimanager@gmail.com
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');

class modP30newsHelper
{
	function getList(&$params)
	{
		global $mainframe;

		$db			=& JFactory::getDBO();
		$user		=& JFactory::getUser();
		$userId		= (int) $user->get('id');

		$count		= (int) $params->get('count', 5);
		$catid		= trim( $params->get('catid') );
		$secid		= trim( $params->get('secid') );
		$show_front	= $params->get('show_front', 1);
		$aid		= $user->get('aid', 0);

		$contentConfig = &JComponentHelper::getParams( 'com_content' );
		$access		= !$contentConfig->get('show_noauth');

		$nullDate	= $db->getNullDate();

		$date =& JFactory::getDate();
		$now = $date->toMySQL();

		$where		= 'a.state = 1'
			. ' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )'
			. ' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )'
			;

		// User Filter
		switch ($params->get( 'user_id' ))
		{
			case 'by_me':
				$where .= ' AND (created_by = ' . (int) $userId . ' OR modified_by = ' . (int) $userId . ')';
				break;
			case 'not_me':
				$where .= ' AND (created_by <> ' . (int) $userId . ' AND modified_by <> ' . (int) $userId . ')';
				break;
		}

		// Ordering
		switch ($params->get( 'ordering' ))
		{
			case 'm_dsc':
				$ordering		= 'a.modified DESC, a.created DESC';
				break;
			case 'c_dsc':
			default:
				$ordering		= 'a.created DESC';
				break;
		}

		if ($catid)
		{
			$ids = explode( ',', $catid );
			JArrayHelper::toInteger( $ids );
			$catCondition = ' AND (cc.id=' . implode( ' OR cc.id=', $ids ) . ')';
		}
		if ($secid)
		{
			$ids = explode( ',', $secid );
			JArrayHelper::toInteger( $ids );
			$secCondition = ' AND (s.id=' . implode( ' OR s.id=', $ids ) . ')';
		}

		// Content Items only
		$query = 'SELECT a.*, ' .
			' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
			' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug'.
			' FROM #__content AS a' .
			($show_front == '0' ? ' LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id' : '') .
			' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
			' INNER JOIN #__sections AS s ON s.id = a.sectionid' .
			' WHERE '. $where .' AND s.id > 0' .
			($access ? ' AND a.access <= ' .(int) $aid. ' AND cc.access <= ' .(int) $aid. ' AND s.access <= ' .(int) $aid : '').
			($catid ? $catCondition : '').
			($secid ? $secCondition : '').
			($show_front == '0' ? ' AND f.content_id IS NULL ' : '').
			' AND s.published = 1' .
			' AND cc.published = 1' .
			' ORDER BY '. $ordering;
		$db->setQuery($query, 0, $count);
		$rows = $db->loadObjectList();

		$i		= 0;
		$lists	= array();
		foreach ( $rows as $row )
		{
			if($row->access <= $aid)
			{
				$lists[$i]->link = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
			} else {
				$lists[$i]->link = JRoute::_('index.php?option=com_user&view=login');
			}
			
			$lists[$i]->text 		= htmlspecialchars( $row->title );
			$lists[$i]->hits		= htmlspecialchars( $row->hits );
			$lists[$i]->introtext 	= ( $row->introtext );
			$lists[$i]->fulltext 	= ( $row->fulltext );
			$lists[$i]->id 			= htmlspecialchars( $row->id );
			$i++;
		}

		return $lists;
	}
	


}
	//Get first or article's images
	function FirstImg($article) {
	$img = "";
	if (preg_match("#<img[^>]+src=['|\"](.*?)['|\"][^>]*>#i", $article, $matches)){$img = $matches[1];}
	return $img;
	}	
	
	function GetintroText ($article,$introlimit,$allow){
	 $introlimit += 10 ;
		$intro = strip_tags ($article, $allow);
		$intro = substr($intro, 0, $introlimit).' ...';
	return $intro;
	}
	
	function GetRating ($articleid){
	$db			=& JFactory::getDBO();
	$rating = array();
	$ratingsumquery = 'SELECT rating_sum FROM #__content_rating WHERE content_id = ' . $articleid;
					$db->setQuery($ratingsumquery);
					$sumrating = $db->loadResult();	
	$ratingcountquery = 'SELECT rating_count FROM #__content_rating WHERE content_id = ' . $articleid;
					$db->setQuery($ratingcountquery);
					$countrating = $db->loadResult();
		if (empty($countrating)) {
		$countrating = 0;
		$ratingimg = '<img src="'.JURI::base().'modules/mod_p30news/images/rating_0.gif" style="margin-top:4px;" />';
	}else{
		$sumrating /= $countrating;
		switch ($sumrating){
		case 0:
		$ratingimg = '<img src="'.JURI::base().'modules/mod_p30news/images/rating_0.gif" style="margin-top:4px;" />';
		break;
		case 1:
		$ratingimg = '<img src="'.JURI::base().'modules/mod_p30news/images/rating_1.gif"  style="padding-top:4px;"/>';
		break;
		case 2:
		$ratingimg = '<img src="'.JURI::base().'modules/mod_p30news/images/rating_2.gif"  style="padding-top:4px;"/>';
		break;
		case 3:
		$ratingimg = '<img src="'.JURI::base().'modules/mod_p30news/images/rating_3.gif"  style="vertical-align:middle"/>';
		break;
		case 4:
		$ratingimg = '<img src="'.JURI::base().'modules/mod_p30news/images/rating_4.gif"  style="padding-top:4px;"/>';
		break;
		case 5:
		$ratingimg = '<img src="'.JURI::base().'modules/mod_p30news/images/rating_5.gif"  style="padding-top:4px;"/>';
		break;
		}
	}
	$rating[0] = $sumrating ;
	$rating[1] = $countrating ;
	$rating[2] = $ratingimg ;
	return $rating;
	}
	
	?>